<?

// SQL-Trace : 0 = false / 1 = true
define("SQL_TRACE", false);

class MySQL_DB{

    var $mess     = "";
    var $con      = false;
    var $fp_trace = false;

//-------------------------------------------------------------------------------------
//                     CONNECT FUNCTIONS
//-------------------------------------------------------------------------------------

    //Konstruktor mit DB-Connection
    function MySQL_DB(){
    }

    function connect( $pagename, $fm_function ){
        if( ( $this->con = mysql_connect( DB_HOST, DB_USER, DB_PASSWORD )) == false ){
            $this->mess.= "Fehler beim DB-Connect :".mysql_error();
            die( "<p>$this->mess in Class MySQL_DB</p>\n" );
        }
        else if( mysql_select_db ( DB_NAME, $this->con ) == false ){
            $this->mess.= "Fehler beim DB-Select :".mysql_error();
            die( "<p>$this->mess in Class MySQL_DB</p>\n" );
        }
        if( SQL_TRACE == 1 ){
            $this->fp_trace = @fopen( "sql_trace.sql", "a+" );
            fwrite( $this->fp_trace, "----------- PAGE: $pagename, FM_FUNCTION: $fm_function ------------\n\n" );
        }
    }

    function disconnect(){
        mysql_close( $this->con );
        if( SQL_TRACE == 1 ) @fclose( $this->fp_trace );
    }


//-------------------------------------------------------------------------------------
//                     PROJECT FUNCTIONS
//-------------------------------------------------------------------------------------


    function insertProject( $sName, $sNr, $iPrjLeiter, $sAbnTermin, $sAend_User, $aiGroups, $sBeschreibung ){
        global $TODAY,$TODAY_TS;

        $rc = false;
        $sAbnTermin = $this->toMySQLDate( $sAbnTermin );

        $sql = "SELECT id FROM tdl_projekte WHERE name = '$sName' AND prj_nr = '$sNr';";
        if( $res=$this->my_db_query( DB_NAME, $sql ) ){
            if( mysql_num_rows($res) > 0 ){
                $this->mess.= "Dieses Projekt ist schon angelegt";
            }
            else{
                $sql = "INSERT INTO tdl_projekte ( name, prj_nr, prj_leiter, abnahmetermin, aend_dat, aend_user, beschreibung ) ";
                $sql.= "VALUES ( '$sName', '$sNr', $iPrjLeiter, '$sAbnTermin', '$TODAY_TS', '$sAend_User', '$sBeschreibung' );";
                if( $this->my_db_query( DB_NAME, $sql ) ){
                    $prj_id = mysql_insert_id( $this->con );
                    $rc = true;
                    for ($i=0; $i < sizeof($aiGroups); $i++) {
                        $sql = "INSERT INTO tdl_prj_gruppen ( prj_id, grp_id ) VALUES ( $prj_id, ".$aiGroups[$i]." );";
                        if( !$this->my_db_query( DB_NAME, $sql ) ){
                            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
                            $rc = false;
                        }
                    }//for
                }
                else{
                    $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
                }
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rc;
    }

    function updateProject( $iID, $sName, $sNr, $iPrjLeiter, $sAbnTermin, $sAend_User, $aiGroups, $sBeschreibung ){
        global $TODAY,$TODAY_TS;

        $rc = false;
        $sAbnTermin = $this->toMySQLDate( $sAbnTermin );

        $sql = "UPDATE tdl_projekte  SET name = '$sName', aend_dat = '$TODAY_TS', prj_nr = '$sNr', ";
        $sql.=  "prj_leiter = $iPrjLeiter, abnahmetermin = '$sAbnTermin', aend_user = '$sAend_User', beschreibung = '$sBeschreibung' ";
        $sql.= "WHERE id = $iID;";
        if( $this->my_db_query( DB_NAME, $sql ) ){
            $sql = "DELETE FROM tdl_prj_gruppen WHERE prj_id = $iID;";
            if( $this->my_db_query( DB_NAME, $sql ) ){
                $rc = true;
                for( $i=0; $i < sizeof( $aiGroups ); $i++ ){
                    $sql = "INSERT INTO tdl_prj_gruppen ( prj_id, grp_id ) VALUES ( $iID, ".$aiGroups[$i]." );";
                    if( !$this->my_db_query( DB_NAME, $sql ) ){
                        $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
                        $rc = false;
                    }
                }
            }
            else{
                $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rc;
    }

    function deleteProject( $iID ){
        global $TODAY,$TODAY_TS;

        $rc = false;
        $sql = "DELETE FROM tdl_prj_gruppen WHERE prj_id = $iID;";
        if( $this->my_db_query( DB_NAME, $sql ) ){
            $sql = "DELETE FROM tdl_eintraege WHERE prj_id = $iID OR ref_id = $iID;";
            if( $this->my_db_query( DB_NAME, $sql ) ){
                $sql = "DELETE FROM tdl_projekte WHERE id = $iID;";
                if( $this->my_db_query( DB_NAME, $sql ) ){
                    $rc = true;
                }
                else{
                    $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
                }
            }
            else{
                $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rc;
    }


    // [ co_entrydetails.php, co_projectinfo.php ]
    function getProject( $iID ){
        global $TODAY,$TODAY_TS;

        $sql = "SELECT id, name, prj_nr, prj_leiter, abnahmetermin as prj_abt, beschreibung ";
        $sql.= "FROM tdl_projekte ";
        $sql.= "WHERE id = $iID;";
        if( $res=$this->my_db_query( DB_NAME, $sql ) ){
            if( $prj=mysql_fetch_object($res) ){
                $prj->prj_abt = $this->toStrDate( $prj->prj_abt );
                return $prj;
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return false;
    }


    function getArrayProject(){
        global $TODAY,$TODAY_TS;
        $rs_arr = array();

        $sql = "SELECT p.id, p.name, p.prj_nr, u.kennung as prj_leiter, abnahmetermin as prj_abt, beschreibung ";
        $sql.= "FROM tdl_projekte p, tdl_user u ";
        $sql.= "WHERE u.id = p.prj_leiter ORDER BY p.id;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            while( $obj = mysql_fetch_object( $res ) ){
                $obj->prj_abt = $this->toStrDate( $obj->prj_abt );

                 array_push( $rs_arr, $obj );
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rs_arr;
    }

    // [ co_projectview.php ]
    function getArrayProjectView( $iUser_ID ){
        global $TODAY,$TODAY_TS;
        $rs_arr = array();

        $sql = "SELECT DISTINCT p.id, p.name, p.prj_nr, u.kennung as prj_leiter, abnahmetermin as prj_abt ";
        $sql.= "FROM tdl_projekte p, tdl_user_gruppen ug, tdl_prj_gruppen pg, tdl_user u ";
        $sql.= "WHERE ug.user_id = $iUser_ID ";
        $sql.= "AND   ug.grp_id  = pg.grp_id ";
        $sql.= "AND   pg.prj_id  = p.id ";
        $sql.= "AND   u.id       = p.prj_leiter ";
        $sql.= "ORDER BY p.id;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            while( $obj = mysql_fetch_object( $res ) ){
                $obj->prj_abt    = $this->toStrDate( $obj->prj_abt );

                array_push( $rs_arr, $obj );
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rs_arr;
    }


    // [ $db->getArrayProjectView() ]
    function getErrorCount( $iPrj_ID, $err_ready ){
        global $TODAY,$TODAY_TS;

        if( $err_ready ){
            $sql = "SELECT COUNT(*) AS ANZ FROM tdl_eintraege ";
            $sql.= "WHERE prj_id = $iPrj_ID AND status_id IN ( ".ST_ID_REJECT.", ".ST_ID_CHECKED." ) AND ref_id = 0;";
        }
        else{
            $sql = "SELECT COUNT(*) AS ANZ FROM tdl_eintraege ";
            $sql.= "WHERE prj_id = $iPrj_ID AND status_id NOT IN ( ".ST_ID_REJECT.", ".ST_ID_CHECKED." ) AND ref_id = 0;";
        }
        if( $res=$this->my_db_query( DB_NAME, $sql ) ){
            if( list($anz)=mysql_fetch_row($res) ){
                return $anz;
            }
            return false;
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return -1;
    }


//-------------------------------------------------------------------------------------
//                     USER FUNCTIONS
//-------------------------------------------------------------------------------------

    // Gibt den LoginUser zurck, andernfalls FALSE
    // [ inc_formfunctions.php ]
    function getLoginUser( $benutzer, $passwort ){
        global $TODAY,$TODAY_TS;

        $this->mess = "";
        $sql = "SELECT id, kennung, name, vorname, email, admin, gesperrt, aend_dat ";
        $sql.= "FROM   tdl_user ";
        $sql.= "WHERE  kennung  = '$benutzer' AND passwort = '$passwort' ";
        $sql.= "AND    geloescht = 0;";
        if( $res=$this->my_db_query( DB_NAME, $sql ) ){
            if( $user = mysql_fetch_object($res) ){
                return $user;
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return false;
    }

    // [ co_myprofile.php ]
    function getUser( $iUser_ID ){
        global $TODAY,$TODAY_TS;

        $sql = "SELECT id, kennung, passwort, name, vorname, email, admin, gesperrt, aend_dat ";
        $sql.= "FROM   tdl_user ";
        $sql.= "WHERE  id = $iUser_ID;";
        if( $res=$this->my_db_query( DB_NAME, $sql ) ){
            if( $user=mysql_fetch_object($res) ){
                $user->aend_dat = $this->toStrDate( $user->aend_dat );
                return $user;
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return false;
    }

    // [ co_userlist.php ]
    function getArrayUser(){
        global $TODAY,$TODAY_TS;
        $rs_arr = array();

        $sql = "SELECT id, kennung, passwort, name, vorname, email, admin, gesperrt, aend_dat ";
        $sql.= "FROM   tdl_user ";
        $sql.= "WHERE  geloescht = 0 ";
        $sql.= "ORDER BY kennung;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            while( $obj = mysql_fetch_object( $res ) ){
                $obj->prj_abt    = $this->toStrDate( $obj->prj_abt );
                //$obj->err_offen  = $this->getErrorCount( $obj->id, false );
                //$obj->err_fertig = $this->getErrorCount( $obj->id, true );
                //$obj->err_total  = $obj->err_offen + $obj->err_fertig;

                array_push( $rs_arr, $obj );
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rs_arr;
    }

    function getArrayProjectUser( $iPrj_ID ){
        global $TODAY,$TODAY_TS;
        $rs_arr = array();

        $sql = "SELECT DISTINCT u.id, u.kennung, u.passwort, u.name, u.vorname, ";
        $sql.=        "u.email, u.admin, u.gesperrt, u.aend_dat ";
        $sql.= "FROM   tdl_user u, tdl_prj_gruppen pg, tdl_user_gruppen ug ";
        $sql.= "WHERE  u.id        = ug.user_id ";
        $sql.= "AND    pg.grp_id   = ug.grp_id ";
        $sql.= "AND    pg.prj_id   = $iPrj_ID ";
        $sql.= "AND    u.geloescht = 0 ";
        $sql.= "ORDER BY u.kennung;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            while( $obj = mysql_fetch_object( $res ) ){

                array_push( $rs_arr, $obj );
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rs_arr;
    }

    // [ co_projectlist.php ]
    function getArrayGroupUser( $iGroup_ID ){
        global $TODAY,$TODAY_TS;
        $rs_arr = array();

        $sql = "SELECT id, kennung, passwort, name, vorname, email, admin, gesperrt, aend_dat ";
        $sql.= "FROM   tdl_user u, tdl_user_gruppen ug ";
        $sql.= "WHERE  u.id        = ug.user_id ";
        $sql.= "AND    ug.grp_id   = $iGroup_ID ";
        $sql.= "AND    u.geloescht = 0 ";
        $sql.= "ORDER BY u.kennung;";

        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            while( $obj = mysql_fetch_object( $res ) ){

                array_push( $rs_arr, $obj );
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rs_arr;
    }

    // [ inc_formfunctions.php ]
    function insertUser( $sKennung, $sPasswort, $sName, $sVorname, $sEMail, $iAdmin, $iGesperrt, $sAend_User, $aiGroups ){
        global $TODAY,$TODAY_TS;

        $rc = false;
        $sql = "INSERT INTO tdl_user( kennung, passwort, name, vorname, email, admin, gesperrt, aend_dat, aend_user ) ";
        $sql.=              " VALUES( '$sKennung', '$sPasswort', '$sName', '$sVorname', '$sEMail', $iAdmin, $iGesperrt, '".TODAY_TS."', '$sAend_User' );";
        if( $res=$this->my_db_query( DB_NAME, $sql ) ){
            $user_id = mysql_insert_id();
            $rc = true;
            if( $aiGroups != - 1 ){
                for( $i=0; $i < sizeof( $aiGroups ); $i++ ){
                    $sql = "INSERT INTO tdl_user_gruppen ( user_id, grp_id ) VALUES ( $user_id, ".$aiGroups[$i]." );";
                    if( !$this->my_db_query( DB_NAME, $sql ) ){
                        $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
                        $rc = false;
                    }
                }
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rc;
    }

    // [ inc_formfunctions.php ]
    function updateUser( $iUser_ID, $sKennung, $sPasswort, $sName, $sVorname, $sEMail, $iAdmin, $iGesperrt, $sAend_User, $aiGroups ){
        global $TODAY,$TODAY_TS;

        $rc = false;
        $sql = "UPDATE tdl_user SET kennung = '$sKennung', passwort = '$sPasswort', name = '$sName' ";
        $sql.=                    ",vorname = '$sVorname', email = '$sEMail', aend_dat = '$TODAY_TS', aend_user = '$sAend_User' ";
        if( $iAdmin != -1 && $iGesperrt != -1 ){
            $sql.= ",admin = $iAdmin, gesperrt = $iGesperrt ";
        }
        $sql.= "WHERE id = $iUser_ID;";
        if( $this->my_db_query( DB_NAME, $sql ) ){
            if( $aiGroups != - 1 ){
                $sql = "DELETE FROM tdl_user_gruppen WHERE user_id = $iUser_ID;";
                if( $this->my_db_query( DB_NAME, $sql ) ){
                    $rc = true;
                    for( $i=0; $i < sizeof( $aiGroups ); $i++ ){
                        $sql = "INSERT INTO tdl_user_gruppen ( user_id, grp_id ) VALUES ( $iUser_ID, ".$aiGroups[$i]." );";
                        if( !$this->my_db_query( DB_NAME, $sql ) ){
                            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
                            $rc = false;
                        }
                    }
                }
                else{
                    $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
                }
            }
            else $rc = true;
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rc;
    }

    // [ inc_formfunctions.php ]
    function deleteUser( $iUser_ID ){
        global $TODAY,$TODAY_TS;

        $sql = "DELETE FROM tdl_user_gruppen WHERE user_id = $iUser_ID;";
        if( false == $this->my_db_query( DB_NAME, $sql ) ){
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        else{
            $sql = "UPDATE tdl_user SET geloescht = 1 WHERE id = $iUser_ID;";
            if( $res=$this->my_db_query( DB_NAME, $sql ) ){
                return true;
            }
            else{
                $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
            }
        }
    }


//-------------------------------------------------------------------------------------
//                     GROUP FUNCTIONS
//-------------------------------------------------------------------------------------

    // [ co_entrydetails.php, co_entryhistorydetails.php ]
    function getArrayProjectGroup( $iPrj_ID ){
        global $TODAY,$TODAY_TS;
        $rs_arr = array();

        $sql = "SELECT g.id, g.gruppe ";
        $sql.= "FROM   tdl_gruppen g, tdl_prj_gruppen pg ";
        $sql.= "WHERE  g.id      = pg.grp_id ";
        $sql.= "AND    pg.prj_id = $iPrj_ID ";
        $sql.= "AND    g.geloescht = 0 ";
        $sql.= "ORDER BY g.gruppe;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            while( $obj = mysql_fetch_object( $res ) ){

                array_push( $rs_arr, $obj );
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rs_arr;
    }

    // [ co_userlist.php ]
    function getArrayGroup(){
        global $TODAY,$TODAY_TS;
        $rs_arr = array();

        $sql = "SELECT g1.id, g1.gruppe, COUNT( DISTINCT pg.prj_id ) + COUNT( DISTINCT ug.user_id ) AS anzahl ";
        $sql.= "FROM tdl_gruppen g1 LEFT JOIN tdl_prj_gruppen  pg ON ( g1.id = pg.grp_id ) ";
        $sql.= "    ,tdl_gruppen g2 LEFT JOIN tdl_user_gruppen ug ON ( g2.id = ug.grp_id ) ";
        $sql.= "WHERE  g1.id = g2.id ";
        $sql.= "AND    g1.geloescht = 0 ";
        $sql.= "GROUP BY g1.id, g1.gruppe ";
        $sql.= "ORDER BY g1.gruppe;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            while( $obj = mysql_fetch_object( $res ) ){

                array_push( $rs_arr, $obj );
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rs_arr;
    }

    // [ co_userlist.php ]
    function getArrayUserGroup( $iUser_ID ){
        global $TODAY,$TODAY_TS;
        $rs_arr = array();

        $sql = "SELECT g.id, g.gruppe ";
        $sql.= "FROM   tdl_gruppen g, tdl_user_gruppen ug ";
        $sql.= "WHERE  g.id       = ug.grp_id ";
        $sql.= "AND    ug.user_id = $iUser_ID ";
        $sql.= "AND    g.geloescht = 0 ";
        $sql.= "ORDER BY g.gruppe;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            while( $obj = mysql_fetch_object( $res ) ){

                array_push( $rs_arr, $obj );
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rs_arr;
    }

    // [ co_grouplist.php ]
    function getGroup( $iID ){
        global $TODAY,$TODAY_TS;

        $sql = "SELECT id, gruppe ";
        $sql.= "FROM   tdl_gruppen ";
        $sql.= "WHERE  id = $iID ";
        $sql.= "AND    geloescht = 0;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            if( $obj = mysql_fetch_object( $res ) ){
                return $obj;
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return false;
    }

    // [ inc_formfunction.php ]
    function insertGroup( $sName ){
        global $TODAY,$TODAY_TS;

        $rc = false;
        $sql = "INSERT INTO tdl_gruppen( gruppe ) VALUES( '$sName' );";

        if( $this->my_db_query( DB_NAME, $sql ) ){
            $rc = true;
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rc;
    }


    // [ inc_formfunction.php ]
    function updateGroup( $iID, $sName ){
        global $TODAY,$TODAY_TS;

        $rc = false;
        $sql = "UPDATE tdl_gruppen SET gruppe ='$sName' ";
        $sql.= "WHERE id = $iID ";
        $sql.= "AND   geloescht = 0;";

        if( $this->my_db_query( DB_NAME, $sql ) ){
            $rc = true;
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rc;
    }

    // [ inc_formfunction.php ]
    function deleteGroup( $iID ){
        global $TODAY,$TODAY_TS;

        $rc = false;
        $sql = "DELETE FROM tdl_prj_gruppen WHERE grp_id = $iID;";
        if( $this->my_db_query( DB_NAME, $sql ) ){

            $sql = "DELETE FROM tdl_user_gruppen WHERE grp_id = $iID;";
            if( $this->my_db_query( DB_NAME, $sql ) ){

                $sql = "UPDATE tdl_gruppen SET geloescht = 1 WHERE id = $iID;";
                if( $this->my_db_query( DB_NAME, $sql ) ){
                    $rc = true;
                }
                else{
                    $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
                }
            }
            else{
                $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rc;
    }


//-------------------------------------------------------------------------------------
//                     ENTRY FUNCTIONS
//-------------------------------------------------------------------------------------

    // [ co_entrydetails.php ]
    function getEntry( $iID ){
        global $TODAY,$TODAY_TS;

        $sql = "SELECT id, eintrag_nr, prioritaet, typ_kz, beschreibung, loesung, grp_id, status_id, ";
        $sql.=        "gefunden_id, behoben_id, geprueft_id ";
        $sql.= "FROM  tdl_eintraege ";
        $sql.= "WHERE id = $iID;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            if( $obj = mysql_fetch_object($res) ){
                $sql = "SELECT id, dateiname, is_pic FROM tdl_anhaenge WHERE ein_id = ".$obj->id;
                $ar_anhang = array();
                if( $res_anh = $this->my_db_query( DB_NAME, $sql ) ){
                    while( list( $id, $dateiname, $is_pic ) = mysql_fetch_array( $res_anh ) ){
                        array_push( $ar_anhang, array( "id"=>$id, "dateiname"=>$dateiname, "is_pic"=>$is_pic ) );
                    }
                }
                else{
                    $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
                }
                $obj->ar_anhang = $ar_anhang;
                return $obj;
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return false;
    }

    // [ co_entrylist.php ]
    function getArrayEntry( $iPrj_ID, $iUser_ID, $sSuche, $iSort ){
        global $TODAY,$TODAY_TS;
        $rs_arr = array();

        $sql = "SELECT DISTINCT e.id, e.eintrag_nr, prioritaet, e.typ_kz, e.beschreibung, e.loesung, g.gruppe, ";
        $sql.=        "e.status_id, e.gefunden_id, e.behoben_id, e.geprueft_id, e.aend_dat, e.aend_user ";
        $sql.= "FROM  tdl_eintraege e, tdl_user_gruppen ug, tdl_gruppen g ";
        $sql.= "WHERE ( ( e.grp_id = ug.grp_id AND ug.user_id = $iUser_ID ) ";
        $sql.=       " OR e.user_id = $iUser_ID ) ";
        $sql.= "AND   e.grp_id   = g.id ";
        $sql.= "AND   e.prj_id   = $iPrj_ID ";
        $sql.= "AND   e.ref_id   = 0 ";
        // zusaetzliches Suchkriterium
        if( $sSuche != "" ) $sql.="AND beschreibung LIKE '%$sSuche%' ";
        // Sortierung
        switch( $iSort ){
        case SORT_TYP_A    : $sql.= "ORDER BY typ_kz ASC;";      break;
        case SORT_TYP_D    : $sql.= "ORDER BY typ_kz DESC;";     break;
        case SORT_PRIO_A   : $sql.= "ORDER BY prioritaet ASC;";  break;
        case SORT_PRIO_D   : $sql.= "ORDER BY prioritaet DESC;"; break;
        case SORT_NR_A     : $sql.= "ORDER BY eintrag_nr ASC;";  break;
        case SORT_NR_D     : $sql.= "ORDER BY eintrag_nr DESC;"; break;
        case SORT_STATUS_A : $sql.= "ORDER BY status_id ASC;";   break;
        case SORT_STATUS_D : $sql.= "ORDER BY status_id DESC;";  break;
        default            : $sql.= "ORDER BY typ_kz, status_id, eintrag_nr;"; break;
        }
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            while( $obj = mysql_fetch_object( $res ) ){
                $obj->aend_dat = $this->toStrDateTime( $obj->aend_dat );

                array_push( $rs_arr, $obj );
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rs_arr;
    }

    // [ inc_formfunctions.php ]
    function insertEntry( $iPrj_ID, $iUser_ID, $iPrio, $cTyp, $sBeschreibung, $sLoesung, $iGroup_ID, $iStatus_ID,
                          $iGefunden_ID, $iBehoben_ID, $iGeprueft_ID, $sAend_User ){
        global $TODAY,$TODAY_TS;

        //hoechste Eintrag-Nr ermitteln
        $sql = "SELECT MAX(eintrag_nr) FROM tdl_eintraege WHERE prj_id = $iPrj_ID AND ref_id = 0;";
        if( $res=$this->my_db_query( DB_NAME, $sql ) ){
            if( false == (list($max)=mysql_fetch_row($res)) ){
                $max = 0;
            }
            $max++;
            //neuen Eintrag hinzufuegen
            $sql = "INSERT INTO tdl_eintraege ( aend_dat, aend_user, prj_id, user_id, eintrag_nr, prioritaet, typ_kz, beschreibung, loesung, ";
            $sql.=                            " grp_id, status_id, gefunden_id, behoben_id, geprueft_id, ref_id ) ";
            $sql.= "VALUES ( '$TODAY_TS', '$sAend_User', $iPrj_ID, $iUser_ID, $max, $iPrio, '$cTyp', '$sBeschreibung', '$sLoesung', ";
            $sql.=          " $iGroup_ID, $iStatus_ID, $iGefunden_ID, $iBehoben_ID, $iGeprueft_ID, 0 );";
            if( $this->my_db_query( DB_NAME, $sql ) ){
                $rc = true;
            }
            else{
                $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rc;
    }

    // [ inc_formfunctions.php ]
    function updateEntry( $iErr_ID, $iPrj_ID, $iUser_ID, $iPrio, $cTyp, $sBeschreibung, $sLoesung, $iGroup_ID, $iStatus_ID,
                          $iGefunden_ID, $iBehoben_ID, $iGeprueft_ID, $sAend_User ){
        global $TODAY,$TODAY_TS;

        $rc = false;
        // Eintrag-Nr selektieren
        $sql = "SELECT eintrag_nr FROM tdl_eintraege WHERE id = $iErr_ID;";
        if( $res=$this->my_db_query( DB_NAME, $sql ) ){
            if( false == (list($eintrag_nr)=mysql_fetch_row($res)) ){
                $eintrag_nr = 0;
            }
            // neuen Eintrag einfuegen (somit ist eine Historie verfuegbar)
            $sql = "INSERT INTO tdl_eintraege ( aend_dat, aend_user, prj_id, user_id, eintrag_nr, prioritaet, typ_kz, beschreibung, loesung, ";
            $sql.=                            " grp_id, status_id, gefunden_id, behoben_id, geprueft_id, ref_id ) ";
            $sql.= "VALUES ( '$TODAY_TS', '$sAend_User', $iPrj_ID, $iUser_ID, $eintrag_nr, $iPrio, '$cTyp', '$sBeschreibung', '$sLoesung', ";
            $sql.=          " $iGroup_ID, $iStatus_ID, $iGefunden_ID, $iBehoben_ID, $iGeprueft_ID, 0 );";
            if( ! $this->my_db_query( DB_NAME, $sql ) ){
                $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
            }
            else{
                // neue ID merken
                $new_entry_id = $this->getLastInsertID();
                // Historien-Eintraege auf die neue ID umbiegen
                $sql = "UPDATE tdl_eintraege SET ref_id = ".$this->getLastInsertID()." ";
                $sql.= "WHERE  id = $iErr_ID ";
                $sql.= "OR ref_id = $iErr_ID;";
                if( $this->my_db_query( DB_NAME, $sql ) ){
                    // alle Anhaenge des vorherigen Eintrages auf den neuen Eintrag kopieren
                    $sql = "SELECT id, dateiname, is_pic FROM tdl_anhaenge WHERE ein_id = ".$iErr_ID;
                    if( $res_anh=$this->my_db_query( DB_NAME, $sql ) ){
                        $rc = true;
                        while( list( $id, $dateiname, $is_pic ) = mysql_fetch_array( $res_anh ) ){
                            if( !$this->addAppendix( $new_entry_id, $dateiname, $is_pic, $sAend_User ) ){
                                $rc = false;
                            }
                        }
                    }
                    else{
                        $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
                    }
                }
                else{
                    $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
                }
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rc;
    }

    // [ inc_formfunctions.php ]
    function deleteEntry( $iErr_ID ){
        global $TODAY,$TODAY_TS;

        $sql = "DELETE FROM tdl_eintraege WHERE id = $iErr_ID OR ref_id = $iErr_ID;";
        if( $this->my_db_query( DB_NAME, $sql ) ){
            return true;
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return false;
    }

    // [ inc_formfunctions.php ]
    function addAppendix( $iErr_ID, $sDateiname, $iIsPic, $sAendUser ){
        global $TODAY,$TODAY_TS;

        $sql = "INSERT INTO tdl_anhaenge ( ein_id, dateiname, is_pic, aend_dat, aend_user ) ";
        $sql.=                  " VALUES ( $iErr_ID, '$sDateiname', $iIsPic, '$TODAY_TS', '$sAendUser' );";
        if( $this->my_db_query( DB_NAME, $sql ) ){
            return true;
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return false;
    }

    // [ inc_formfunctions.php ]
    function deleteAppendix( $iApp_ID ){
        global $TODAY,$TODAY_TS;

        $sql = "DELETE FROM tdl_anhaenge WHERE id = $iApp_ID;";
        if( $this->my_db_query( DB_NAME, $sql ) ){
            return true;
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return false;
    }

    // [ inc_formfunctions.php ]
    function getAppendix( $iApp_ID ){
        global $TODAY,$TODAY_TS;

        $sql = "SELECT * FROM tdl_anhaenge WHERE id = $iApp_ID;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            if( $obj = mysql_fetch_object( $res ) ){
                return $obj;
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return false;
    }

    // [ inc_formfunctions.php ]
    function getArrayAppendix( $iErr_ID, $iPrj_ID ){
        global $TODAY,$TODAY_TS;
        $rs_arr = array();

        if( $iErr_ID > 0 && $iPrj_ID <= 0 ) $sql = "SELECT id FROM tdl_eintraege WHERE id = $iErr_ID OR ref_id = $iErr_ID;";
        if( $iErr_ID <= 0 && $iPrj_ID > 0 ) $sql = "SELECT id FROM tdl_eintraege WHERE prj_id = $iPrj_ID;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            while( $obj_ein = mysql_fetch_object( $res ) ){
                $sql = "SELECT * FROM tdl_anhaenge WHERE ein_id = ".$obj_ein->id.";";
                if( $res2 = $this->my_db_query( DB_NAME, $sql ) ){
                    while( $obj = mysql_fetch_object( $res2 ) ){

                        array_push( $rs_arr, $obj );
                    }
                }
                else{
                    $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
                }
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rs_arr;
    }

    // [ co_entryhistorylist.php ]
    function getArrayHistoryEntry( $iErr_ID, $iSort ){
        global $TODAY,$TODAY_TS;
        $rs_arr = array();

        $sql = "SELECT id, eintrag_nr, prioritaet, typ_kz, beschreibung, loesung, grp_id, aend_dat, ";
        $sql.= "aend_user, status_id, gefunden_id, behoben_id, geprueft_id ";
        $sql.= "FROM tdl_eintraege ";
        $sql.= "WHERE ref_id = $iErr_ID ";
        // Sortierung
        switch( $iSort ){
        case SORT_TYP_A    : $sql.= "ORDER BY typ_kz ASC;";      break;
        case SORT_TYP_D    : $sql.= "ORDER BY typ_kz DESC;";     break;
        case SORT_PRIO_A   : $sql.= "ORDER BY prioritaet ASC;";  break;
        case SORT_PRIO_D   : $sql.= "ORDER BY prioritaet DESC;"; break;
        case SORT_NR_A     : $sql.= "ORDER BY eintrag_nr ASC;";  break;
        case SORT_NR_D     : $sql.= "ORDER BY eintrag_nr DESC;"; break;
        case SORT_STATUS_A : $sql.= "ORDER BY status_id ASC;";   break;
        case SORT_STATUS_D : $sql.= "ORDER BY status_id DESC;";  break;
        default            : $sql.= "ORDER BY aend_dat DESC;";   break;
        }
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            while( $obj = mysql_fetch_object( $res ) ){
                $obj->aend_dat = $this->toStrDateTime( $obj->aend_dat );

                array_push( $rs_arr, $obj );
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rs_arr;
    }

    function moveEntryToProject( $iErr_ID, $iPrj_ID ){
        global $TODAY,$TODAY_TS;
        $rs_arr = array();

        $rc = false;
        $sql = "SELECT MAX(eintrag_nr) FROM tdl_eintraege WHERE prj_id = $iPrj_ID AND ref_id = 0;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
           if( !( list($max)=mysql_fetch_row($res) ) ){
               $max = 0; //bei noch keinem Eintrag --> Eintrag-Nr auf 0 setzen
           }
           $max++;
           $sql = "UPDATE tdl_eintraege SET prj_id = $iPrj_ID, eintrag_nr = $max ";
           $sql.= "WHERE id = $iErr_ID OR ref_id = $iErr_ID;";
           if( $this->my_db_query( DB_NAME, $sql ) ){
               return true;
           }
           else{
               $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
           }
        }
        else{
           $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rc;
    }



//-------------------------------------------------------------------------------------
//                 EINTRAGS-UEBERSICHT FUNKTION (Tabelle)
//-------------------------------------------------------------------------------------

    function getArrayEntryTable( $iUser, $sPrj_ID, $iGroup_ID, $iStatus_ID ){
        global $TODAY,$TODAY_TS;
        $rs_arr = array();

        $sql = "SELECT f.id, p.name, p.prj_nr, p.id AS prj_id, u.kennung, f.eintrag_nr, f.typ_kz, f.aend_dat, ";
        $sql.= " f.beschreibung, f.loesung, g.gruppe, f.status_id ";
        $sql.= "FROM tdl_eintraege f, tdl_projekte p, tdl_user u, tdl_gruppen g, tdl_user_gruppen ug ";
        $sql.= "WHERE f.prj_id     = p.id ";
        $sql.= "AND   f.ref_id     = 0 ";
        $sql.= "AND   f.grp_id     = g.id ";
        $sql.= "AND   ug.grp_id    = g.id ";
        $sql.= "AND   p.prj_leiter = u.id ";
        $sql.= "AND   ug.user_id   = $iUser ";
        if( $sPrj_ID     != "" )  $sql.= "AND p.id         = '$sPrj_ID' ";
        if( $iGroup_ID   != "" )  $sql.= "AND f.grp_id     = $iGroup_ID ";
        if( $iStatus_ID  != "" )  $sql.= "AND f.status_id  = $iStatus_ID ";
        $sql.= "ORDER BY p.id, f.eintrag_nr;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            while( $obj = mysql_fetch_object( $res ) ){
                $obj->aend_dat = $this->toStrDateTime( $obj->aend_dat );
                if( $obj->beschreibung == "" ) $obj->beschreibung = "&nbsp;";
                if( $obj->loesung      == "" ) $obj->loesung      = "&nbsp;";

                array_push( $rs_arr, $obj );
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rs_arr;
    }

//-------------------------------------------------------------------------------------
//                     MESSAGE FUNCTIONS
//-------------------------------------------------------------------------------------

    function getArrayMyMessages( $iUser_ID ){
        global $TODAY,$TODAY_TS;
        $rs_arr = array();

        $sql = "SELECT m.id, m.betreff, m.text, mu.gelesen, mu.geloescht, ";
        $sql.=       " m.to_user_id, m.to_group_id, m.aend_dat, m.aend_user, ";
        $sql.=       " u.kennung AS from_user_kz, u.email AS from_email ";
        $sql.= "FROM  tdl_messages m LEFT JOIN tdl_user u ON ( m.from_user_id = u.id ) ";
        $sql.=     " ,tdl_mess_user mu ";
        $sql.= "WHERE m.id = mu.mess_id ";
        $sql.= "  AND mu.user_id = $iUser_ID ";
        $sql.= "  AND mu.geloescht = 0 ";
        $sql.= "ORDER BY m.aend_dat DESC;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            while( $obj = mysql_fetch_object( $res ) ){
                $obj->aend_dat = $this->toStrDateTime( $obj->aend_dat );
                array_push( $rs_arr, $obj );
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rs_arr;
    }

    function getArraySendMessages( $iUser_ID ){
        global $TODAY,$TODAY_TS;
        $rs_arr = array();

        $sql = "SELECT m.id, m.text, m.betreff, MAX( mu.gelesen ) AS gelesen, MAX( mu.geloescht ) AS geloescht, m.from_user_id, ";
        $sql.=       " m.to_user_id, m.to_group_id, m.aend_dat, m.aend_user, ";
        $sql.=       " u.kennung AS to_user_kz, u.email AS to_email ";
        $sql.= "FROM  tdl_messages m  LEFT JOIN tdl_user u ON ( m.to_user_id = u.id ) ";
        $sql.=      ",tdl_mess_user mu ";
        $sql.= "WHERE m.id           = mu.mess_id ";
        $sql.= "AND   m.from_user_id = $iUser_ID ";
        $sql.= "GROUP BY m.id, m.text, m.betreff, m.from_user_id, m.to_user_id, m.to_group_id, m.aend_dat, m.aend_user ";
        $sql.= "ORDER BY m.aend_dat DESC;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            while( $obj = mysql_fetch_object( $res ) ){
                $obj->aend_dat = $this->toStrDateTime( $obj->aend_dat );
                array_push( $rs_arr, $obj );
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rs_arr;
    }

    function getMessage( $iMess_ID, $iUser_ID = 0 ){
        global $TODAY,$TODAY_TS;

        $sql = "SELECT m.id, m.text, m.betreff, mu.gelesen, mu.geloescht, m.from_user_id, ";
        $sql.=       " m.to_user_id, m.to_group_id, m.aend_dat, m.aend_user, ";
        $sql.=       " u.kennung AS from_user_kz, u.email AS from_email ";
        $sql.= "FROM  tdl_messages m  LEFT JOIN tdl_user u ON ( m.from_user_id = u.id ) ";
        $sql.=      ",tdl_mess_user mu ";
        $sql.= "WHERE m.id       = mu.mess_id ";
        $sql.= "  AND m.id       = $iMess_ID ";
        if( $iUser_ID > 0 ) $sql.= "AND mu.user_id = $iUser_ID;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            if( $obj = mysql_fetch_object( $res ) ){
                $obj->aend_dat = $this->toStrDateTime( $obj->aend_dat );
                return $obj;
            }
            else{
                $this->mess.= "Fehler beim SQL-Fetch ".mysql_error();
            }
        }
        else{
           $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return false;
    }

    function setMessageToReaded( $iMess_ID, $iUser_ID, $sAend_User ){
        global $TODAY,$TODAY_TS;

        $sql = "UPDATE tdl_mess_user m SET m.gelesen = 1, m.aend_dat = '$TODAY_TS',  m.aend_user = '$sAend_User' ";
        $sql.= "  WHERE m.mess_id = $iMess_ID AND m.user_id = $iUser_ID;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            return true;
        }
        else{
           $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return false;
    }

    function setMessageToDelete( $iMess_ID, $iUser_ID, $sAend_User ){
        global $TODAY,$TODAY_TS;

        $sql = "UPDATE tdl_mess_user m SET m.geloescht = 1, m.gelesen = 1, m.aend_dat = '$TODAY_TS', m.aend_user = '$sAend_User' ";
        $sql.= "  WHERE m.mess_id = $iMess_ID AND m.user_id = $iUser_ID;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            return true;
        }
        else{
           $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return false;
    }

    function deleteMessage( $iMess_ID ){
        global $TODAY,$TODAY_TS;

        $sql = "DELETE FROM tdl_mess_user WHERE mess_id = $iMess_ID;";
        if( $this->my_db_query( DB_NAME, $sql ) ){
            $sql = "DELETE FROM tdl_messages WHERE id = $iMess_ID;";
            if( $this->my_db_query( DB_NAME, $sql ) ){
                return true;
            }
        }
        else{
           $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return false;
    }

    function sendMessage( $sBetreff, $sText, $iFrom_User_ID, $iTo_User_ID, $iTo_Group_ID, $sAend_User ){
        global $TODAY,$TODAY_TS;
        $rc = true;

        if( $iTo_User_ID  == "" ) $iTo_User_ID  = "NULL";
        if( $iTo_Group_ID == "" ) $iTo_Group_ID = "NULL";
        $sql = "INSERT INTO tdl_messages ( betreff, text, from_user_id, to_user_id, to_group_id, aend_dat, aend_user ) ";
        $sql.=                  " VALUES ( '$sBetreff', '$sText', $iFrom_User_ID, $iTo_User_ID, $iTo_Group_ID, '$TODAY_TS', '$sAend_User' );";
        if( $this->my_db_query( DB_NAME, $sql ) ){
            $mess_id = $this->getLastInsertID();
            //wenn Mail fuer Benutzer --> Beziehung einfuegen
            if( $iTo_User_ID > 0 ){
                $sql = "INSERT INTO tdl_mess_user ( user_id, mess_id, aend_dat, aend_user ) ";
                $sql.=                   " VALUES ( $iTo_User_ID, $mess_id, '$TODAY_TS', '$sAend_User' );";
                if( ! $this->my_db_query( DB_NAME, $sql ) ){
                    $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
                    $rc = false;
                }
            }
            else{
                //wenn Mail an Gruppe --> Beziehung fuer jeden Benutzer einfuegen
                $rs_arr = $this->getArrayGroupUser( $iTo_Group_ID );
                for( $i=0; $i < sizeof( $rs_arr ); $i++ ){
                    $row = $rs_arr[$i];
                    $sql = "INSERT INTO tdl_mess_user ( user_id, mess_id, aend_dat, aend_user ) ";
                    $sql.=                   " VALUES ( ".$row->id.", $mess_id, '$TODAY_TS', '$sAend_User' );";
                    if( ! $this->my_db_query( DB_NAME, $sql ) ){
                        $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
                        $rc = false;
                    }
                }
            }
        }
        else{
           $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
           $rc = false;
        }
        return $rc;
    }

    function getNewMessageCount( $iUser_ID ){
        global $TODAY,$TODAY_TS;

        $sql = "SELECT COUNT(*) AS anz FROM tdl_mess_user WHERE gelesen = 0 AND user_id = $iUser_ID;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            if( $obj = mysql_fetch_object( $res ) ){
                return $obj->anz;
            }
            else{
                $this->mess.= "Fehler beim SQL-Fetch ".mysql_error();
            }
        }
        else{
           $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return false;



    }

//-------------------------------------------------------------------------------------
//                     STATISTIK FUNCTIONS
//-------------------------------------------------------------------------------------

    function getArrayPrjEntryCounts(){
        global $TODAY,$TODAY_TS;
        $rs_arr = array();

        $sql = "SELECT COUNT(*)AS anzahl, p.name ";
        $sql.= "FROM  tdl_projekte p, tdl_eintraege f ";
        $sql.= "WHERE f.prj_id = p.id ";
        $sql.= "AND   f.ref_id = 0 ";
        $sql.= "GROUP BY p.name;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            while( $obj = mysql_fetch_object( $res ) ){
                array_push( $rs_arr, $obj );
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rs_arr;
    }

    function getArrayStatiEntryCounts( $iPrj_ID ){
        global $TODAY,$TODAY_TS;
        $rs_arr = array();

        $sql = "SELECT status_id, COUNT(*) AS anzahl ";
        $sql.= "FROM     tdl_eintraege f ";
        $sql.= "WHERE    f.prj_id = $iPrj_ID ";
        $sql.= "AND      f.ref_id = 0 ";
        $sql.= "GROUP BY f.status_id;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            while( $obj = mysql_fetch_object( $res ) ){
                array_push( $rs_arr, $obj );
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rs_arr;
    }

    function getEntryDurations( $iPrj_ID, $iMin_Status_ID, $iMax_Status_ID ){
        global $TODAY,$TODAY_TS;

        $sql = "SELECT MIN((TO_DAYS(f1.aend_dat)-TO_DAYS(f2.aend_dat))) AS minimum, ";
        $sql.= "MAX((TO_DAYS(f1.aend_dat)-TO_DAYS(f2.aend_dat))) AS maximum, ";
        $sql.= "AVG((TO_DAYS(f1.aend_dat)-TO_DAYS(f2.aend_dat))) AS durchschnitt ";
        $sql.= "FROM tdl_eintraege f1, tdl_eintraege f2 ";
        $sql.= "WHERE f1.prj_id    = $iPrj_ID ";
        $sql.= "AND   f2.prj_id    = $iPrj_ID ";
        $sql.= "AND   f1.ref_id    = 0 ";
        $sql.= "AND   f2.ref_id   != 0 ";
        $sql.= "AND   f1.status_id = $iMax_Status_ID ";
        $sql.= "AND   f2.status_id = $iMin_Status_ID ";
        $sql.= "AND   f1.id       != f2.id;";
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            if( $obj = mysql_fetch_object( $res ) ){
                return $obj;
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return false;
    }


//-------------------------------------------------------------------------------------
//                     SONSTIGE FUNCTIONS
//-------------------------------------------------------------------------------------

    // Fuehrt jedes SQL-Statements aus und loggt ggf. die SQL-Befehle mit
    function my_db_query( $db_name, $sql ){
        if( SQL_TRACE ){
            $sql = str_replace( "VALUES", "\nVALUES", $sql );
            $sql = str_replace( "FROM ",   "\nFROM ",   $sql );
            $sql = str_replace( "WHERE ",  "\nWHERE ",  $sql );
            $sql = str_replace( "AND ",    "\nAND ",    $sql );
            $sql = str_replace( "ORDER ",  "\nORDER ",  $sql );
            $sql = str_replace( "GROUP ",  "\nGROUP ",  $sql );
            @fwrite( $this->fp_trace, $sql."\n\n" );
        }
        return mysql_db_query( $db_name, $sql );
    }

    function getErrorMessage( $no_err=true ){
        if( $no_err ) return $this->mess;
        else          return $this->mess." in Class MySQL_DB";
    }

    function getLastInsertID(){
        return mysql_insert_id( $this->con );
    }

    function toStrDate( $datum ){
        if( trim( $datum ) != "" ){
            list( $datum, $uhrzeit ) = split( " ", $datum );
            $arr = split( '[/.-]', $datum );
            $datum = trim( $arr[2].".".$arr[1].".".$arr[0] );
        }
        return trim( $datum );
    }

    function toStrDateTime( $datum ){
        if( trim( $datum ) != "" ){
            list( $datum, $uhrzeit ) = split( " ", $datum );
            $arr = split( '[/.-]', $datum );
            $datum = $arr[2].".".$arr[1].".".$arr[0]." / ".$uhrzeit;
        }
        return trim( $datum );
    }

    function toMySQLDate( $datum ){
        if( trim( $datum ) != "" ){
            $arr = split('[/.-]', $datum);
            $datum = $arr[2]."-".$arr[1]."-".$arr[0];
        }
        return trim( $datum );
    }

    function getMaskLabels( $sMaske, $iSprache ){
        global $TODAY,$TODAY_TS;
        $rs_arr = array();
        $sMaske = strtoupper( $sMaske );

        $sql = "SELECT id, bezeichnung FROM tdl_labels ";
        $sql.= " WHERE ( id LIKE 'GLOBAL_%' OR id LIKE '".$sMaske."_%' ) ";
        $sql.= " AND     sprach_id = $iSprache;";
        //echo $sql;
        if( $res = $this->my_db_query( DB_NAME, $sql ) ){
            while( $obj = mysql_fetch_object( $res ) ){
                $rs_arr[$obj->id] = $obj->bezeichnung;
            }
        }
        else{
            $this->mess.= "Fehler beim SQL-Statement : $sql ".mysql_error();
        }
        return $rs_arr;
    }


};

?>