<?

class Picture{

    var $default_pic = "";
    
    function Picture( $fn_default="" ){
        $this->default_pic = $fn_default;
    }
    

    //resize Picture ( thumbs, picture, fotos etc. )
    function resizePicture( $fn_src, $fn_des, $width=-1, $height=-1, $fn_default="", $only_minimize=true, $qualitiy=82 ){

        //set default picture
        if( $fn_default == "" ) $fn_default = $this->default_pic;
        
        //if the picture no available
        if( is_file( $fn_src ) ){
            
            //if no set a size
            if( $width == -1 && $height == -1 ){
                $fn_pic = $fn_default;
                //$fn_pic = $fn_src;
            }
            else{
                $fn_pic = $fn_des;
                $info = getimagesize( $fn_src );
                $b_src = $info[0];
                $h_src = $info[1];
                if( $width != -1 ){
                    $b = $width;
                    $h = ceil( $h_src * $b / $b_src );
                }
                else{
                    $h = $height;
                    $b = ceil( $b_src * $h / $h_src );
                }
                //if picture only minimize
                if( ( $only_minimize && $h < $h_src ) || !$only_minimize ){
                    if( $h > $b ){
                        $h = $width;
                        $b = ceil( $b_src * $h / $h_src );
                    }
                    switch($info[2]){
                    case 1: $im_src = imagecreatefromgif( $fn_src );
                            break;
                    case 2: $im_src = imagecreatefromjpeg( $fn_src );
                            break;
                    case 3: $im_src = imagecreatefrompng( $fn_src );
                            break;
                    }
                    $im_pic = imagecreatetruecolor( $b, $h );
                    imagecopyresampled( $im_pic, $im_src, 0 , 0 , 0 , 0, $b, $h, $b_src, $h_src );
                    imagejpeg( $im_pic, $fn_pic, $qualitiy );
                    imagedestroy( $im_src );
                    imagedestroy( $im_pic );
                }
                else{
                    $fn_pic = $fn_src;
                }
            }
        }
        else{
            $fn_pic = $fn_default;
        }
        return $fn_pic;
    }

};





?>