<?
    import_request_variables( "gpc" );

    include_once ( "inc_configuration.php" );
    include_once ( "classes/mysql_db.class.php" );
    include_once ( "classes/statistics_pdf.class.php" );

    //DB - Klasse erstellen
    $db = new MySQL_DB();
    $arr_prj_enc = array();
    $arr_sta_enc = array();

    //PDF Kopf erzeugen
    $pdf = new StatisticPDF();
    $pdf->AliasNbPages();
    $pdf->AddPage();
    $pdf->SetFont('Arial','',10);

    // Beim Auswerten von Eintragen und Projekten
    if( stristr( $entrys_all_projects, "ON") ){
        // Projekte und die Anzahl der Eintraege (Fehler)
        $max_1 = 0;
        $rs_arr = $db->getArrayPrjEntryCounts();
        for( $i=0; $i < sizeof( $rs_arr ); $i++ ){
            $row = $rs_arr[$i];
            if( $row->anzahl > $max_1 ) $max_1 = $row->anzahl;
            $arr = array( "name"=>$row->name, "anzahl"=>$row->anzahl );
            array_push( $arr_prj_enc, $arr );
        }
        $pdf->setProjectEntryCounts( $arr_prj_enc, $max_1 );
    }
    if( stristr( $stati_entrycounts,   "ON") ){
        // Statis und deren Anzahl eines Projektes
        $max_2 = 0;
        $rs_arr = $db->getArrayStatiEntryCounts( $projekt_1 );
        for( $i=0; $i < sizeof( $rs_arr ); $i++ ){
            $row = $rs_arr[$i];
            if( $row->anzahl > $max_2 ) $max_2 = $row->anzahl;
            $arr = array( "status"=>$ARR_STATUS[ $row->status_id ], "anzahl"=>$row->anzahl );
            array_push( $arr_sta_enc, $arr );
        }
        $pdf->setStatiEntryCounts( $arr_sta_enc, $max_2 );
    }
    if( stristr( $entry_duration,      "ON") ){
        // Dauer min, max & durchschn. der Statifolge eines Projektes
        $min = $max = $avg = 0;
        if( $res = $db->getEntryDurations( $projekt_2, 0, 3 ) ){
            $min = $res->minimum + 0;
            if( $min < 0 ) $min = 0;
            $max = $res->maximum + 0;
            if( $max < 0 ) $max = 0;
            $avg = round( $res->durchschnitt, 2 );
            if( $avg < 0 ) $avg = 0;
        }
        $pdf->setEntryDurations( $min, $max, $avg );
    }

    // PDF ausgeben
    $pdf->Output();

?>