
    //checkt ein Feld ab
    function checkField( field, check_type ){
        //alert( field+","+check_type);
        var err="", err_s="";
        var ra = null;
        if( check_type == "NONE" ) return err;
        if( field      == ""     ) err = "nicht eingegeben";
        else{
            switch(check_type){
            //email
            case "EMAIL":   ra = /[a-z0-9]+[\.a-z0-9_-]+@([0-9a-z][0-9a-z-]*[0-9a-z]\.)+([a-z]{2,4}|museum)/i ;
                            err_s = "nicht korrekt";
                            break;
            //plz
            case "PLZ":     ra = /^[0-9]{5}$/i ;
                            err_s = "nicht korrekt ( Format 38000 )";
                            break;
            //zahl
            case "ZAHL":    ra = /^[0-9]+$/ ;
                            err_s = "nicht korrekt";
                            break;
            //fliesskomma zahl
            case "FK_ZAHL": ra = /^[0-9]{1,9}(\.|,)[0-9]{1,9}$/ ;
							err_s = "nicht korrekt";
							break;
            //telefon
            case "TELEFON": ra = /^[0-9]{3,5}( |-|\/)*[0-9]{3,8}$/i ;
                            err_s = "nicht korrekt ( Format: 0815 / 123 )";
                            break;
            //text
            case "TEXT":    ra = /./
                            err_s = "nicht gefllt";
                            break;
            //datum (01.01.1972)
            case "DATUM":   ra = /^[0-9]{2}\.[0-9]{2}\.[0-9]{4}$/ ;
                            err_s = "nicht korrekt ( Format: 01.01.2003 )";
                            break;
            //uhrzeit (05:25)
            case "UHRZEIT": ra = /^[0-9]{2}(\.|:)[0-9]{2}$/ ;
                            err_s = "nicht korrekt ( Format: 01:20 )";
                            break;
            case "URL":     ra = /^(http:\/\/)[a-z0-9.\/_-]+$/i ;
                            err_s = "nicht korrekt ( Format: http://www.domain.de/bild_x.gif ) ";
                            break;
            /////////////   bei falschem Modus ////////////////////////
            default:        err = "SCRIPT ERROR -> falscher CHECK_TYPE";
                            return err;
            }//switch

            if( field.search( ra ) == -1 ){
                err = err_s;
            }
        }
        //alert( "ERROR: '"+err+"'" );
        return err;
    }


	function getSelectedValue( selectBox ){
		var k;
		for( k=0; k < selectBox.length; k++ ){
        	if( selectBox.options[k].selected ){
            	return selectBox.options[k].value;
            }
        }
        return "";
	}
