<?

   if( $sess->get( "s_tdl_user_id" ) == "" && $curl->getValue( PAGE ) != "home"  ){
        //URL zum Weiterleiten nach Login speichern
        $sess->set( "s_url", $curl->getCurl() );
        //zum Login leiten
        $curl->setValue( "home", PAGE );
        $href_home = $curl->getCurl();
        header ("Location: $href_home");
        exit;
    }

    if( isset( $fm_function ) ){

        switch( $fm_function ){

            //Beim Login, Inserat wird aus den Inseratmasken zwischengespeichert
            case "fm_login":{
                $sess->set( "s_tdl_user_id", "" );
                $sess->set( "s_dyn_size", $dyn_size );
                if( $user = $db->getLoginUser( $benutzer, $passwort ) ){

                    if( $user->gesperrt == 1 ){
                        $gl_js .= "alert( '".$label['HOME_M02']."!' );\n";
                    }
                    else{
                        $sess->set( "s_tdl_user_id", $user->id );
                        $sess->set( "s_user_kz", $user->kennung );
                        $sess->set( "s_user_admin", $user->admin );
                        if( $sess->get( "s_url" ) != "" ){
                            $href_prj_view = $sess->get( "s_url" );
                            $sess->set( "s_url", "" );
                        }
                        else{
                            $curl->setValue( "myprofile", PAGE );
                            $href_prj_view = $curl->getCurl();
                        }
                        header ( "Location: $href_prj_view" );
                        exit;
                    }
                }
                else{
                    $gl_js .= "alert( '".$label['HOME_M03']."!' );\n";
                }
                break;
            }

            //Beim Logout
            case "fm_logout":{
                $sess->set( "s_tdl_user_id" ,"" );
                $sess->set( "s_user_kz", "" );
                $sess->set( "s_user_admin", "" );
                $sess->set( "s_suche", "" );
                break;
            }

            // Mail senden bei neuem Projekt
            case "fm_mail_newproject":{

                $curl->setValue( "projectview", PAGE );
                $href_mail = $curl->getCurl();

                $url     = "http://".$SERVER_NAME.$href_mail;
                $betreff = $label['PROJECTLIST_M08'];
                $text    = $label['PROJECTLIST_M09'];
                $text    = str_replace( "#FIRMA#", $FIRMA, $text );
                $text    = str_replace( "#URL#", $url, $text );
                $text    = str_replace( "#PROJECT_NAME#", $prj_name, $text );

                $email_anz = $util->sendMail( $curl->getValue( PROJECT_ID ), $betreff, $text );
                $message = $label['PROJECTLIST_M10'];
                $message = str_replace( '#ANZAHL#', $email_anz, $message );
                $gl_js.= "alert( '$message!' );\n";
                break;
            }

            // Projekt speichern
            case "fm_save_project":{
                // Wenn Projekt ID = 0 das muss der Datensatz neu eingefgt werden (INSERT)
                if( $curl->getValue( PROJECT_ID ) == 0 ){
                    if( ! $db->insertProject( $prj_name, $prj_nr, $prj_ltr, $prj_abt, $sess->get( "s_user_kz" ), $select_groups, $beschreibung ) ){
                        $gl_js .= "alert( '".$label['PROJECTLIST_M05']."!' )\n";
                    }
                }
                // Andernfalls muss das Projekt gespeichert werden (UPDATE)
                else{
                    if( ! $db->updateProject( $curl->getValue( PROJECT_ID ), $prj_name, $prj_nr, $prj_ltr, $prj_abt, $sess->get( "s_user_kz" ), $select_groups, $beschreibung ) ){
                        $gl_js .= "alert( '".$label['PROJECTLIST_M05']."!' )\n";
                    }
                }
                break;
            }

            case "fm_delete_project":{
                // ggf. Anhaenge auch von Eintraghistorien loeschen
                $rs_arr = $db->getArrayAppendix( 0, $curl->getValue( PROJECT_ID ) );
                for( $i=0; $i < sizeof( $rs_arr ); $i++ ){
                    $row = $rs_arr[$i];
                    if( $db->deleteAppendix( $row->id ) ){
                        @unlink( BIN_DIR."/".$row->dateiname );
                        if( $row->is_pic ) @unlink( THUMB_DIR."/tmb_".$row->dateiname );
                    }
                    else{
                        $gl_js .= "alert( '".$label['PROJECTLIST_M06']."!' )\n";
                    }
                }
                if( ! $db->deleteProject( $curl->getValue( PROJECT_ID ) ) ){
                    $gl_js .= "alert( '".$label['PROJECTLIST_M07']."!' )\n";
                }
                break;
            }

            // Mail senden bei neuem Eintrag
            case "fm_mail_newentry":{
                $href_mail = $curl->getCurl();

                $url     = "http://".$SERVER_NAME.$href_mail;
                $betreff = $label['ENTRYLIST_M06'];
                $text    = $label['ENTRYLIST_M07'];
                $text    = str_replace( "#FIRMA#", $FIRMA, $text );
                $text    = str_replace( "#URL#", $url, $text );

                $email_anz = $util->sendMail( $curl->getValue( PROJECT_ID ), $betreff, $text );
                $message = $label['ENTRYLIST_M08'];
                $message = str_replace( '#ANZAHL#', $email_anz, $message );
                $gl_js .= "alert( '$message!' );\n";
                break;
            }

            // Eintrag speichern
            case "fm_save_entry":{
                // wenn Entry_ID = 0, Eintrag wird neu eingefuegt (INSERT)
                if( $curl->getValue( ENTRY_ID ) == 0 ){
                    if( $db->insertEntry( $curl->getValue( PROJECT_ID ), $sess->get( "s_tdl_user_id" ), $prioritaet, $typ, $beschreibung, $loesung,
                                          $grp_id, $status_id, $gefunden_id, $behoben_id, $geprueft_id, $sess->get( "s_user_kz" ) ) ){
                        $curl->setOriValue( $db->getLastInsertID(), ENTRY_ID );
                    }
                }
                //wenn Entry_ID > 0 ist, Eintrag wird neu eingefuegt, Eintrag-Historie zeigt auf neuen Fehler
                else{
                    if( $db->updateEntry( $curl->getValue( ENTRY_ID ), $curl->getValue( PROJECT_ID ), $sess->get( "s_tdl_user_id" ), $prioritaet, $typ, $beschreibung, $loesung,
                                          $grp_id, $status_id, $gefunden_id, $behoben_id, $geprueft_id, $sess->get( "s_user_kz" ) ) ){
                    }
                }
                // nach Insert bzw. Update zur Liste immer Eintrag ID leeren
                if( $curl->getValue( PAGE ) == "entrylist" ){
                    $curl->setOriValue( 0, ENTRY_ID );
                }
                // Daten loeschen
                $eintrag_nr = $beschreibung = $loesung = "";
                $grp_id = $status_id  = $gefunden_id  = $behoben_id = $geprueft_id = 0;
                $prioritaet = 1;
                break;
            }

            // Eintrag loeschen
            case "fm_delete_entry":{
                // ggf. Anhaenge auch von Eintraghistorien loeschen
                $rs_arr = $db->getArrayAppendix( $curl->getValue( ENTRY_ID ), 0 );
                for( $i=0; $i < sizeof( $rs_arr ); $i++ ){
                    $row = $rs_arr[$i];
                    if( $db->deleteAppendix( $row->id ) ){
                        @unlink( BIN_DIR."/".$row->dateiname );
                        if( $row->is_pic ) @unlink( THUMB_DIR."/tmb_".$row->dateiname );
                    }
                    else{
                        $gl_js .= "alert( '".$label['ENTRYLIST_M03']."!' )\n";
                    }
                }
                if( ! $db->deleteEntry( $curl->getValue( ENTRY_ID ) ) ){
                    $gl_js .= "alert( '".$label['ENTRYLIST_M04']."!' )\n";
                }
                break;
            }

            //Anhang speichern
            case "fm_save_appendix":{
                if( $dateiname != "" ){
                    $p   = strpos( $dateiname, "." );
                    $fn  = strtolower( substr( $dateiname, 0, $p ) );
                    $ext = strtolower( substr( $dateiname, $p+1 ) );
                    $dateiname  = $fn."_".uniqid( rand() ).".".$ext;
                    $pfad       = BIN_DIR."/".$dateiname;
                    $pfad_thumb = THUMB_DIR."/tmb_".$dateiname;

                    if( ($rc = $util->upload_file( $pic, $anhang, $pfad, $pfad_thumb, $is_pic )) == "" ){
                        if( !$db->addAppendix( $curl->getValue( ENTRY_ID ), $dateiname, $is_pic, $sess->get( "s_user_kz" ) ) ){
                            $gl_js .= "alert( '".$label['ENTRYDETAILS_M07']."!' );";
                        }
                    }
                    else{
                        $gl_js .= "alert( \"$rc\" );\n";
                        @unlink( BIN_DIR."/".$pfad );
                        @unlink( $pfad_thumb );
                    }
                }
                break;
            }

            // Anhang loeschen
            case "fm_delete_appendix":{
                $obj = $db->getAppendix( $anhang_id );
                if( $db->deleteAppendix( $anhang_id ) ){
                    @unlink( BIN_DIR."/".$obj->dateiname );
                    if( $obj->is_pic ) @unlink( THUMB_DIR."/tmb_".$obj->dateiname );
                }
                else{
                    $gl_js .= "alert( '".$label['ENTRYDETAILS_M08']."!' );";
                }
                break;
            }

            // Eintrag in anderes Projekt verschieben
            case "fm_move_entry":{
               // Beim Verschieben eines Eintrages in ein anderes Projekt

               if( ! $db->moveEntryToProject( $curl->getValue( ENTRY_ID ), $prj_id ) ){
                   $gl_js .= "alert( '".$label['ENTRYLIST_M05']."!' )\n";
               }
               break;
            }

            // eigenes Profil speichern
            case "fm_save_profile":{
                if( $sess->get( "s_tdl_user_id" ) != "" ){
                    if( ! $db->updateUser( $sess->get( "s_tdl_user_id" ), $kennung, $passwort_1, $name, $vorname,
                                           $email, -1, -1, $sess->get( "s_user_kz" ), -1 ) ){
                        $gl_js .= "alert( '".$label['MYPROFILE_M03']."!' )\n";
                    }
                }
                break;
            }

            // Benutzer speichern ( Benutzer-Admin )
            case "fm_save_user":{
                $admin_op = $gesperrt_op = 0;
                if( stristr($admin,    "ON")) $admin_op    = 1;
                if( stristr($gesperrt, "ON")) $gesperrt_op = 1;
                if( $curl->getValue( USER_ID ) > 0 ){
                    if( ! $db->updateUser( $curl->getValue( USER_ID ), $kennung, $passwort_1, $name, $vorname, $email,
                                           $admin_op, $gesperrt_op, $sess->get( "s_user_kz" ), $select_groups ) ){
                        $gl_js .= "alert( '".$label['USERLIST_M04']."!' )\n";
                    }
                }
                else if( $curl->getValue( USER_ID ) == 0 ){
                    if( ! $db->insertUser( $kennung, $passwort_1, $name, $vorname, $email,
                                           $admin_op, $gesperrt_op, $sess->get( "s_user_kz" ), $select_groups ) ){
                        $gl_js .= "alert( '".$label['USERLIST_M04']."!' )\n";
                    }
                }
                break;
            }

            // Benutzer loeschen ( Benutzer-Admin )
            case "fm_delete_user":{
                if( $curl->getValue( USER_ID ) > 0 ){
                    if( ! $db->deleteUser( $curl->getValue( USER_ID ) ) ){
                        $gl_js .= "alert( '".$label['USERLIST_M05']."!' )\n";
                    }
                }
                break;
            }

            // Gruppe speichern ( Gruppen-Admin )
            case "fm_save_group":{
                if( $curl->getValue( GROUP_ID ) > 0 ){
                    if( ! $db->updateGroup( $curl->getValue( GROUP_ID ), $gruppe ) ){
                        $gl_js .= "alert( '".$label['GROUPLIST_M03']."!' )\n";
                    }
                }
                else if( $curl->getValue( GROUP_ID ) == 0 ){
                    if( ! $db->insertGroup( $gruppe ) ){
                        $gl_js .= "alert( '".$label['GROUPLIST_M03']."!' )\n";
                    }
                }
                break;
            }

            // Gruppe loeschen ( Gruppen-Admin )
            case "fm_delete_group":{
                if( $curl->getValue( GROUP_ID ) > 0 ){
                    if( ! $db->deleteGroup( $curl->getValue( GROUP_ID ) ) ){
                        $gl_js .= "alert( '".$label['GROUPLIST_M04']."!' )\n";
                    }
                }
                break;
            }

            // Message senden ( einfuegen )
            case "fm_send_message":{
                if( ! $db->sendMessage( $betreff, $text, $sess->get( "s_tdl_user_id" ), $to_user_id, $to_group_id, $sess->get( "s_user_kz" ) ) ){
                    $gl_js .= "alert( '".$label['MESSAGELIST_M06']."!' )\n";
                }
                break;
            }

            // eigene Message loeschen ( Message wird NUR auf geloescht gesetzt )
            case "fm_set_message_delete":{
                if( ! $db->setMessageToDelete( $curl->getValue( MESS_ID ), $sess->get( "s_tdl_user_id" ), $sess->get( "s_user_kz" ) ) ){
                    $gl_js .= "alert( '".$label['MESSAGELIST_M07']."!' )\n";
                }
                else $curl->setOriValue( 0, MESS_ID );
                break;
            }

            // gesendete Message loeschen ( Message wird tatsaechlich geloescht )
            case "fm_message_delete":{
                if( ! $db->deleteMessage( $curl->getValue( MESS_ID ) ) ){
                    $gl_js .= "alert( '".$label['MESSAGELIST_M07']."!' )\n";
                }
                else $curl->setOriValue( 0, MESS_ID );
                break;
            }
        }//switch

    }//if isset
?>