<?

if( !is_file( "inc_configuration.php" ) )
    die( "Konfigurationsdatei <b>'inc_configuration.php'</b> fehlt, ist eine Installation erfolgt?</br>
          zur Installationsroutine gehts <a href='install/'>hier</a>" );

import_request_variables( "gpc" );

// Definitionen der HTML-Seiten
// Format: Seitenname => Array( Lang-Pagename, Frameset, Content 1, Content 2, Content 3 ... )

$ar_pagedef = array(

  "home"                => array(  "HOME",          "fs_main.php",          "co_mainmenue.php",    "co_login.php",               "co_empty.php" ),
  "projectview"         => array(  "PROJECTVIEW",   "fs_main.php",          "co_mainmenue.php",    "co_projectview.php",         "co_empty.php" ),
  "entrylist"           => array(  "ENTRYLIST",     "fs_main.php",          "co_ent_submenue.php", "co_entrylist.php",           "co_empty.php" ),
  "entryedit"           => array(  "ENTRYDETAILS",  "fs_main.php",          "co_ent_submenue.php", "co_entrydetails.php",        "co_empty.php" ),
  "newentry"            => array(  "ENTRYDETAILS",  "fs_main.php",          "co_ent_submenue.php", "co_entrydetails.php",        "co_empty.php" ),
  "entryhistorylist"    => array(  "ENTRYLIST",     "fs_main.php",          "co_ent_submenue.php", "co_entryhistorylist.php",    "co_empty.php" ),
  "entryhistorydetails" => array(  "ENTRYDETAILS",  "fs_main.php",          "co_ent_submenue.php", "co_entryhistorydetails.php", "co_empty.php" ),
  "projectchoose"       => array(  "PROJECTCHOOSE", "co_projectchoose.php", "",                    "",                           ""             ),
  "myprofile"           => array(  "MYPROFILE",     "fs_main.php",          "co_mainmenue.php",    "co_myprofile.php",           "co_empty.php" ),
  "mymessagelist"       => array(  "MESSAGELIST",   "fs_main.php",          "co_mainmenue.php",    "co_mymessagelist.php",       "co_empty.php" ),
  "sendmessagelist"     => array(  "MESSAGELIST",   "fs_main.php",          "co_mainmenue.php",    "co_sendmessagelist.php",     "co_empty.php" ),
  "entrytable"          => array(  "ENTRYTABLE",    "fs_main.php",          "co_mainmenue.php",    "co_entrytable.php",          "co_empty.php" ),
  "statistics"          => array(  "STATISTICS",    "fs_main.php",          "co_mainmenue.php",    "co_statistics.php",          "co_empty.php" ),
  "userlist"            => array(  "USERLIST",      "fs_main.php",          "co_mainmenue.php",    "co_userlist.php",            "co_empty.php" ),
  "grouplist"           => array(  "GROUPLIST",     "fs_main.php",          "co_mainmenue.php",    "co_grouplist.php",           "co_empty.php" ),
  "projectlist"         => array(  "PROJECTLIST",   "fs_main.php",          "co_mainmenue.php",    "co_projectlist.php",         "co_empty.php" ),
  "projectinfo"         => array(  "PROJECTINFO",   "fs_main.php",          "co_mainmenue.php",    "co_projectinfo.php",         "co_empty.php" )

);

$gl_js = "";

include_once ( "inc_configuration.php" );
include_once ( "classes/mysql_db.class.php" );
include_once ( "classes/curl.class.php" );
include_once ( "classes/utility.class.php" );
include_once ( "classes/picture.class.php" );
include_once ( "classes/session.class.php" );

// CURL, DB, FORM - Klasse erstellen
$curl = new Curl( $CURL );
$db   = new MySQL_DB();
$pic  = new Picture();
$util = new Utility();
$sess = new Session( USE_SESSION_COOKIES );

$ar_page = $ar_pagedef[ $curl->getValue( PAGE ) ];

if( sizeof( $ar_page ) > 0 ){

    $db->connect( $curl->getValue( PAGE ), $fm_function );

    // Sessionfunktionen aktivieren
    $sess->registerVariables( array( "s_url", "s_dyn_size", "s_tdl_user_id",
                                     "s_user_kz", "s_user_admin", "s_suche" ) );

    header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
    header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");
    header("Cache-Control: no-cache");
    header("Pragma: no-cache");
    header("Cache-Control: post-check=0, pre-check=0");

    // alle globalen und Maskenspezifischen Labels im Array $label bereitstellen
    $label = $db->getMaskLabels( $ar_page[0], $curl->getValue( LANG_ID ) );
    // Formularfunktionen einbinden
    include_once ( "inc_formfunctions.php" );

    // Auslieferungsbeginn mit HTML-DOCTYPE
    echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n";

    // Frameset mit jeweiligen Content-Places einbinden
    include ( $ar_page[1] );

    $db->disconnect();
}
else{
    // Auslieferungsbeginn mit HTML-DOCTYPE
    echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n";
    echo "<html><head></head><body><p>ERROR: Es wurde keine Page definiert</p></body></html>\n";
}


// Ausgabe des globalen Javascript (z.B. Meldungen)
echo "<script type=\"text/javascript\" language=\"javascript\">\n";
if( $gl_js != "" ) echo $gl_js."\n\n";

// Ausgabe evtl. Datenbankfehler
if( $db->getErrorMessage() != "" ) echo "alert ( \"DB-ERROR: ".$db->getErrorMessage()."\" );\n";
echo "</script>\n";


?>