<?

//------  Variables to configure -------------------------------------------------------------------------


    // Datenbank-Configuration / Datebase-Configuration
    define("DB_NAME",              "#DB_NAME#"); // Datenbank-Name
    define("DB_HOST",              "#DB_HOST#"); // Datenbank-Host
    define("DB_USER",              "#DB_USER#"); // Datenbank-Benutzer
    define("DB_PASSWORD",      "#DB_PASSWORD#"); // Datenbank-Passwort


    // Pfadangaben / Pathentrys
    define("FPDF_FONTPATH",            "font/"); // Fonts fuer PDFs ( NICHT aendern! / NOT change )
    define("BIN_DIR",                 "anhang"); // Anhang Directory
    define("THUMB_DIR",           "anhang/tbn"); // Anhang Thumbs bei JPGs
    define("THUMB_WIDTH",                  100); // Thumbnail-Breite


    // Sonstiges / Diverse
    define("EMAIL_ADDRESS", "webmaster@server"); // E-Mail-Adresse
    define("RELEASE",                   "2.20"); // Release-Version
    define("FIRMA",                   "KADIBA"); // Firmenname oder Teamkennung
    define("USE_SESSION_COOKIES",         true); // Cookies fuer Sessions benutzen false=Nein / true=Ja
    define("SESSION_NAME",         "PHPSESSID"); // Sessionname
    define("DEFAULT_TYP",                  "N"); // Standard-Typ fuer neue Eintraege
    define("DEFAULT_SIZE",                   1); // Dynamische Groessenanpassung ( 1 - 5, 1 f. 1024x768 );


    // Styles ( bei Farben NUR Hex-Werte angeben! ) / Styles ( on Color only HEX-Values! )
    /*  ------- Blue-Style -------- */

    define("COLOR_TEXT",              "000060"); // TX-Farbe der Seite
    define("COLOR_BG",                "FFFFFF"); // HG-Farbe der Seite
    define("COLOR_BG_MENUE",          "000060"); // HG-Farbe des Menues
    define("COLOR_BG_MENUE_2",        "999999"); // HG-Farbe2 des Menues
    define("COLOR_BG_TABLE",          "E5EBF7"); // HG-Farbe der Tabellen
    define("COLOR_BG_TABLE_ROW",      "D8E5F0"); // HG-Farbe der geraden Tabellen-Zeile
    define("COLOR_BORDER",            "000000"); // Randfarbe
    define("COLOR_MLINK",             "FFFFFF"); // TX-Farbe von Hyperlinks ( Menue )
    define("COLOR_MLINK_AKTIV",       "FFFFFF"); // TX-Farbe vom aktiven Hyperlink ( Menue )
    define("COLOR_MLINK_HOVER",       "FF0000"); // TX-Farbe vom MouseOver Hyperlink ( Menue )
    define("COLOR_LLINK",             "000000"); // TX-Farbe von Hyperlinks ( Liste )
    define("COLOR_LLINK_AKTIV",       "000000"); // TX-Farbe vom aktiven Hyperlink ( Liste )
    define("COLOR_LLINK_HOVER",       "FF0000"); // TX-Farbe vom MouseOver Hyperlink ( Liste )
    define("HG_PICTURE",   "images/hg_led.gif"); // HG-Bild
    define("TEXT_TYPE",                "Arial"); // Schriftart
    define("TEXT_SIZE",                      9); // Schriftgroesse

    /*  ------- Orange-Style ------- */
    /*
    define("COLOR_TEXT",              "000060"); // TX-Farbe der Seite
    define("COLOR_BG",                "FFFFFF"); // HG-Farbe der Seite
    define("COLOR_BG_MENUE",          "000060"); // HG-Farbe des Menues
    define("COLOR_BG_MENUE_2",        "DEB887"); // HG-Farbe2 des Menues
    define("COLOR_BG_TABLE",          "FFE4B5"); // HG-Farbe der Tabellen
    define("COLOR_BG_TABLE_ROW",      "DEB887"); // HG-Farbe der geraden Tabellen-Zeile
    define("COLOR_BORDER",            "000000"); // Randfarbe
    define("COLOR_MLINK",             "000000"); // TX-Farbe von Hyperlinks ( Menue )
    define("COLOR_MLINK_AKTIV",       "000000"); // TX-Farbe vom aktiven Hyperlink ( Menue )
    define("COLOR_MLINK_HOVER",       "3300FF"); // TX-Farbe vom MouseOver Hyperlink ( Menue )
    define("COLOR_LLINK",             "000000"); // TX-Farbe von Hyperlinks ( Liste )
    define("COLOR_LLINK_AKTIV",       "000000"); // TX-Farbe vom aktiven Hyperlink ( Liste )
    define("COLOR_LLINK_HOVER",       "3300FF"); // TX-Farbe vom MouseOver Hyperlink ( Liste )
    define("HG_PICTURE",   "images/hg_led.gif"); // HG-Bild
    define("TEXT_TYPE",                "Arial"); // Schriftart
    define("TEXT_SIZE",                      9); // Schriftgroesse
    */




/*************************************************************************************************
    ACHTUNG!   Ein nachtrgliches ndern der Statis kann sich auf das System auswirken, da nur
               die IDs in der Datenbank gespeichert werden
    ATTENTION! To change states later can bad affects to the system. Only IDs will saved in the
               database
*************************************************************************************************/

    // Statis der Eintraege / States for the Entrys ( IDs are 0,1,2...)
    $ARR_STATUS = array( "unerledigt", "abgelehnt", "wird bearbeitet", "erledigt", "geprft" );

    define("ST_ID_REJECT",  1);  // Status fuer Benutzereintragung von "abgelehnt"
    define("ST_ID_READY",   3);  // Status fuer Benutzereintragung von "gefunden", "behoben"
    define("ST_ID_CHECKED", 4);  // Status fuer Benutzereintragung von "geprft"

    // Eintragtypen mit Schluessel (Schluessel=>Wert) / Entrytyps with Keys (Key=>Value)
    $ARR_TYP = array( "F"=>"Fehler", "N"=>"Neu", "H"=>"Hinweis"  );





//------  Fix Variables, Do NOT change !!! ---------------------------------------------------------------


    // Globale Variablen, NICHT aendern! / global Variables, NOT change!
    $TODAY    = date( "Y-m-d" );       // Tagesdatum Format: JJJJ-MM-TT
    $TODAY_TS = date( "Y-m-d H:i:s" ); // Tages-Zeit Format: JJJJ-MM-TT HH:MM:SS
    $ARR_DIM  = array( 1=>768, 2=>884, 3=>960, 4=>1200, 5=>1440 );  // Dynamische Hoehe

    // Sortier-Konstanten, NICHT aendern! / Sort Constants, NOT change!
    define("SORT_DEFAULT",             0);
    define("SORT_TYP_A",               1);
    define("SORT_TYP_D",               2);
    define("SORT_PRIO_A",              3);
    define("SORT_PRIO_D",              4);
    define("SORT_NR_A",                5);
    define("SORT_NR_D",                6);
    define("SORT_STATUS_A",            7);
    define("SORT_STATUS_D",            8);

    // Curl-Konstanten, NICHT aendern! / Curl Constants, NOT change!
    define("PAGE",                     0);
    define("REF_PAGE",                 1);
    define("PROJECT_ID",               2);
    define("ENTRY_ID",                 3);
    define("HISTORY_ID",               4);
    define("USER_ID",                  5);
    define("GROUP_ID",                 6);
    define("SORT_ID",                  7);
    define("LANG_ID",                  8);
    define("MESS_ID",                  9);

?>